<?php

namespace Tests\Feature\Models;

use App\Models\User;
use Database\Factories\UserFactory;
use Illuminate\Foundation\Testing\DatabaseMigrations;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Tests\TestCase;

class UserTest extends TestCase
{
    use DatabaseMigrations;
    use RefreshDatabase;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
    }

    public function testCreateTokenShouldReturnAValidTokenInstanceWhenCalledONAnExistingUser(): void
    {
        // data creation
        $user = UserFactory::new()->create();

        // call the method, class
        $token = $user->createToken();

        // assertions
        $this->assertDatabaseCount('tokens', 1);
        $this->assertNotNull($token);

        $this->assertEquals($user->id, $token->user_id);
        $this->assertNotNull($token->token);
        $this->assertTrue($token->expires_at->lte(now()->addMinutes(61)));
    }

    public function testCreateTokenOnANullInstanceShouldThrowAnException(): void
    {
        $this->expectException('Error');
        User::find(1)->creatToken();
    }
}
